'--------- Main_R1.bas --------------------
'Author: Hacker - DuinoMiteMegaAndy
'Date: 4/4/2011
'App. Version: Rev. 1.0b
'MMBasic Firmware: 3.1 on the DuinoMite Mega
'Platform: Win XP/SP3
'Application: MM/DM Synapse Mesh RF Networking
'----------Code Begin--------------
Cls
? Date$,Time$,"User Application Started"
'zero the data file and print the heading
Open "B:Datalog.XLS" For output As #1
Print #1, "Date/Time/Wireless Event"
Print #1
Close #1
' Setup DM Com2 to receive mesh events
Open "Com2:9600,256" As #5
'Open "Com2:19200,256" As #5 
Msg$ = "MM/DM System Has Been Reset/Reboot"
LogMesh Msg$
Msg$ = "User Application Started"
LogMesh Msg$
FlushRxBuf 5
'--------------------------------------------------------------------------------
' Note: On all POR/Reboot/Reset SD log file contents will be intentially destroyed!
' Creating another log file with "append" would keep all data logs intact and safe.
'---------------------------------------------------------------------------------
Start:
Pause 200  'needed!
' data from RF100 to EOF
Loop2:
Rx$ = Input$(30,#5)
If (Eof(5) = False) Then GoTo Loop2
' Print data to video
If (Len(Rx$)) != 0 Then
  If (Len(Rx$)) >= 3 Then
  ' Display mesh event on video
  'chk for cr lf
  T$ = Chr$(13) + Chr$(10)
  x = Instr(rx$,T$)
  '? "cr LF pos = ";x
  If x = 0 Then  GoTo start 'no crlf
  ' remove cr lf
  nl = Len(Rx$)
  Rx$ = Left$(Rx$,(nl-2))
  '
  ' Check for all valid strings and log to SD card.
  '---------------------------------------------------
  ' Message strings from RF node "Mesh Central"
  '---------------------------------------------------
  If Rx$ = "M5"  Then Rx$ = "You got USPS Mail": GoTo prtvid
  If Rx$ = "M6"  Then Rx$ = "Someone got your Mail": GoTo prtvid
  If Rx$ = "M7"  Then Rx$ = "Garage Door Open": GoTo prtvid
  If Rx$ = "M8"  Then Rx$ = "Garage Door Close": GoTo prtvid
  If Rx$ = "M9"  Then Rx$ = "Garage Door HH1 Activate": GoTo prtvid
  If Rx$ = "M10" Then Rx$ = "Garage Door MC Activate": GoTo prtvid
  If Rx$ = "M11" Then Rx$ = "Sys MB Bat Warning": GoTo prtvid
  If Rx$ = "M12" Then Rx$ = "Sys MB Bat Bad": GoTo prtvid
  If Rx$ = "M13" Then Rx$ = "Sys HH1 Bat Warning": GoTo prtvid
  If Rx$ = "M14" Then Rx$ = "Sys HH1 Bat Bad": GoTo prtvid
  If Rx$ = "M1" Then Rx$ = "Sys Garage Door Error 1": GoTo prtvid
  If Rx$ = "M2" Then Rx$ = "Sys Garage Door Error 2": GoTo prtvid
  If Rx$ = "M3" Then Rx$ = "Sys Garage Door Open": GoTo prtvid
  If Rx$ = "M4" Then Rx$ = "Sys Garage Door Close": GoTo prtvid
  'default
  flushrxbuf 5
  GoTo start
  prtvid:
  ? Date$,Time$,Rx$
  ' Log Data to SD Card
  LogMesh Rx$
  FlushRxBuf 5 'added
  EndIf
EndIf
GoTo start
End
'--------------
'Subroutines
'--------------
Sub LogMesh (data$)
Open "B:0atalog.xls" For append As #1
Print #1,Date$,Time$,Rx$
Close #1
End Sub
'------------------------------
Sub FlushRxBuf (nbr)
Local RecBuf$
Loopx:
RecBuf$ = Input$(30,nbr)
If (Eof(nbr) = False) Then GoTo loopx
RecBuf$ = ""
End Sub
'-------------------------------
End


